'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Logger = exports.Logger = function () {
    function Logger() {
        var level = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : DEBUG;
        var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {
            write: function write() {
                var _console;

                (_console = console).log.apply(_console, arguments);
            }
        };

        _classCallCheck(this, Logger);

        this.level = level;
        this.writer = writer;
    }

    _createClass(Logger, [{
        key: 'debug',
        value: function debug(tag, body) {
            if (this.level > DEBUG) return;

            var _ref = arguments.length >= 2 ? [tag, body] : [this.fromStack(), tag],
                _ref2 = _slicedToArray(_ref, 2),
                _tag = _ref2[0],
                _body = _ref2[1];

            this.writer.write('%c[' + _tag + ']', 'color: #ddd; font-weight: bold;', _body);
        }
    }, {
        key: 'info',
        value: function info(tag, body) {
            if (this.level > INFO) return;

            var _ref3 = arguments.length >= 2 ? [tag, body] : [this.fromStack(), tag],
                _ref4 = _slicedToArray(_ref3, 2),
                _tag = _ref4[0],
                _body = _ref4[1];

            this.writer.write('%c[' + _tag + ']%c', 'color: blue; font-weight: bold;', '', _body);
        }
    }, {
        key: 'warn',
        value: function warn(tag, body) {
            if (this.level > WARN) return;

            var _ref5 = arguments.length >= 2 ? [tag, body] : [this.fromStack(), tag],
                _ref6 = _slicedToArray(_ref5, 2),
                _tag = _ref6[0],
                _body = _ref6[1];

            this.writer.write('%c[' + _tag + ']%c', 'color: orange; font-weight: bold;', '', _body);
        }
    }, {
        key: 'fromStack',
        value: function fromStack() {
            var depth = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 3;

            return new Error().stack.split('\n')[depth].trim(); //.split(' ').slice(0,2).join(' ')
        }
    }]);

    return Logger;
}();

var DEBUG = exports.DEBUG = 0;
var INFO = exports.INFO = 1;
var WARN = exports.WARN = 2;

var DummyLogger = exports.DummyLogger = function () {
    function DummyLogger() {
        _classCallCheck(this, DummyLogger);
    }

    _createClass(DummyLogger, [{
        key: 'debug',
        value: function debug() {}
    }, {
        key: 'info',
        value: function info() {}
    }, {
        key: 'warn',
        value: function warn() {}
    }]);

    return DummyLogger;
}();