'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * TODO: write something ;)
 */
var SerialRouter = exports.SerialRouter = function () {
    function SerialRouter() {
        var length = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 4;
        var resolver = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

        _classCallCheck(this, SerialRouter);

        this.routes = [];
        this.poollength = length;
        this.sequencepool = [];
        this.resolver = function () {
            if (typeof resolver == 'function') return resolver;
            var r = {};
            Object.keys(resolver).map(function (key) {
                if (typeof resolver[key] == 'function') r[key] = resolver[key];
            });
            return r;
        }();
        for (var i = 0; i < length; i++) {
            this.sequencepool.push({});
        }
    }

    _createClass(SerialRouter, [{
        key: 'on',
        value: function on(matcher, handlerFunc) {
            var _this = this;

            if (typeof matcher == 'function') {
                this.routes.push({ matchFunc: matcher, handlerFunc: handlerFunc });
                return this;
            }
            if (Array.isArray(matcher) && matcher.length != 0) {
                var funcs = matcher.map(function (m) {
                    switch (typeof m === 'undefined' ? 'undefined' : _typeof(m)) {
                        case 'boolean':
                            return function () {
                                return m;
                            };
                        case 'string':
                            if (typeof _this.resolver != 'function') throw 'resolver must be given when you use simple string matcher';
                            return function (detail) {
                                return m == _this.resolver(detail);
                            };
                        case 'object':
                            return function (detail) {
                                return Object.keys(m).every(function (key) {
                                    if (m[key] instanceof RegExp) return m[key].test(detail[key]);
                                    if (typeof m[key] == 'string') {
                                        if (typeof _this.resolver[key] == 'function') {
                                            return m[key] == _this.resolver[key](detail[key], detail);
                                        } else {
                                            return m[key] == detail[key];
                                        }
                                    }
                                    return false;
                                });
                            };
                        default:
                            return function () {
                                return false;
                            };
                    }
                });
                var matchFunc = function matchFunc(sequence) {
                    return funcs.every(function (fn, i) {
                        return fn(sequence[i]);
                    });
                };
                this.routes.push({ matchFunc: matchFunc, handlerFunc: handlerFunc });
            }
            return this;
        }
    }, {
        key: 'match',
        value: function match() {
            for (var i = 0; i < this.routes.length; i++) {
                if (this.routes[i].matchFunc.call(this, this.sequencepool.slice(0))) {
                    return this.routes[i].handlerFunc;
                }
            }
        }
    }, {
        key: 'listen',
        value: function listen(detail) {
            this.sequencepool.unshift(detail);
            this.sequencepool = this.sequencepool.slice(0, this.poollength);
            // TODO: Logger should be global for this module.
            // this.logger.debug(this.constructor.name, this.sequencepool);
            var handlerFunc = this.match();
            if (handlerFunc) {
                // TODO: Logger should be global for this module.
                // this.logger.info(this.constructor.name, handlerFunc.name);
                handlerFunc.call({ sequence: this.sequencepool.slice(0) }, detail);
            }
            return true;
        }
    }, {
        key: 'listener',
        value: function listener() {
            return this.listen.bind(this);
        }
    }]);

    return SerialRouter;
}();